=== debian/changelog ===
stress-ng (0.13.05-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: rename README to README.md in the make dist rule
  * Manual: update date
  * README.md: Add note to run make clean after git fetch
  * README.md: add some examples
  * README.md: Clean up white spaces in markup
  * README.md: add citations
  * README: Rename to README.me and add github style markdown
  * Revert "stress-aio-linux: clean up valgrind uninitialized memory
    warnings"
  * stress-dev: only define PPGETTIME{32|64} if PP_IOCT is defined
  * stress-ng.h: Fix missing \ in STRESS_PRAGMA_WARN_OFF macro
  * Revert "stress-cache: add clobbering warning pragma workaround"
  * stress-cache: add clobbering warning pragma workaround
  * stress-dev: don't declare stress_dev_scsi_generic_linux for
    non-linux targets
  * stress-dev: remove EMU debug message
  * stress-aio: clean async io cancel, check status with aio_error
  * stress-vm: clear up volatile discards warning with pedantic build
  * stress-kill: send signals to a child process to add more stress
  * stress-branch: double number of branch points, makes prediction
    harder for CPU
  * stress-vm: add mscan vm memory exercising method
  * stress-malloc: add yield point in stress_malloc_page_touch
  * stress-link: make reandom number index size_t
  * stress-get: initialize some objects to keep valgrind happy
  * stress-dirdeep: fix cleanup of dirent objects
  * stress-aio: add polled wait for completion
  * stress-aio-linux: clean up valgrind uninitialized memory warnings
  * stress-context: memset context requires and more sigaltstack
  * stress-hsearch: free hash items
  * core-smart: re-write begin/end checks
  * stress-thermal-zone: don't pass a null type to stress_tz_type_instance
  * Manual: clarify the semantics of the --timeout, -t option
  * stress-uprobe: ensure libc.so is also matched as a valid libc so name
  * Manual: remove GNU tbl extensions for table widths
  * stress-dev: exercise Linux scsi generic ioctls
  * stress-io-uring: keep track of unsupported opcodes
  * stress-fpunch: add yield check while populating test file
  * stress-io-uring: print opcode name to help decode opcode to human
    readable text
  * stress-dev: add parallel port ioctl device exercising
  * stress-io-uring: add statx and sync_file_range io-uring ops
  * stress-crypt: add some more crypto methods to exercise
  * stress-cpu-online: just limit to maximum of 65536 cpus
  * stress-context: rename __ prefix with suitable name
  * stress-context: remove empty line
  * core-thrash: add more slab work by attempting to shrink slabs
  * stress-dev: add hwrng exercising for linux
  * stress-dev: shuffle dev names rather than mixup sort
  * stress-dev: add Linux floppy disk ioctls to dev stressor
  * stress-iomix: add sync'ing on written data at most every second
  * Add new --no-oom-adjust option to disable all oom adjustments
  * core-out-of-memory: fix inverted check on oomable process
  * stress-ng: add missing ftrace and oomable options from --help output
  * snapcraft: change project repo URL

 -- Colin King <colin.king@canonical.com>  Mon, 11 Oct 2021 18:18:18 +0100

stress-ng (0.13.04-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-fallocate: Fix ENOENT failure messages
  * stress-sock: remove redundant variable msg_len
  * stress-dccp: remove redundant variable msg_len
  * stress-prefetch: add missing volatile in pointer cast
  * core-vmstat: optimization: remove check for non-null
  * core-vmstat: reduce scope of variable ret
  * stress-mergesort: don't jmp out of mergesort on NetBSD
  * stress-vm-segv: Fix weird hangs on DragonFlyBSD
  * stress-chmod: add EPERM check to systems that also support EFTYPE
  * stress-rmap: fix rmap bogo-ops threshold
  * Fix typo: HAVE_LOFF_T -> HAVE_OFF_T
  * Add off_t type detection and use it if loff_t is not defined
  * stress-prefetch: prefix macros with STRESS_ to avoid FreeBSD
    macro conflict
  * stress-prefetch: fix mmap/munmap type warnings on OpenHipster
  * stress-prefetch: use correct format specifier for size_t variable
    l3_data_mmap_size
  * stress-prefetch: add stress_void_ptr_put and use it to stash pointers
  * stress-prefetch: Add a L3 prefetch read benchmarking stressor
  * stress-fifo: exercise invalid mmap on fifo fd
  * stress-fifo: periodically exercise FIONREAD on read end of pipe
  * stress-fifo: periodically perform invalid lseek on pipe fd
  * stress-pthread: use phread_mutexattr calls to use priority
    inheritence
  * stress-misaligned: perform misaligned read/writes on page and cache
    boundaries

 -- Colin King <colin.king@canonical.com>  Tue, 28 Sep 2021 11:02:11 +0100

stress-ng (0.13.03-1) unstable; urgency=medium

  * Makefile: bump version
  * stress-remap: Fix build failure on systems without MAP_POPULATE

 -- Colin King <colin.king@canonical.com>  Fri, 17 Sep 2021 12:33:12 +0100

stress-ng (0.13.02-1) unstable; urgency=medium

  [Fabien Malfoy]
  * core-helper: Quote the system-info.version value in YAML metrics
  [Danilo Krummrich]
  * core-vmstat: fix trim of devnames for nvme devices

  [Colin Ian King]
  * Makefile: bump version
  * Manual: update update contributors list and date
  * Signed-off-by: Colin Ian King <colin.king@canonical.com>
  * core-vmstat: make helper function static and constify arg
  * stress-opcode: clean up clang-11 pedantic build warning
  * stress-aio: perform retry if EBUSY occurs
  * stress-vm: constify end pointers
  * stress-stream: constify pointers idx1, idx2, idx3
  * stress-opcode: make pointer ops_end const
  * stress-msync: make pointer buf const
  * stress-mcontend: constify pointer vdata
  * stress-malloc: move scope of ptr and end, constify end
  * stress-malloc: make parameters counters const
  * Treewide: fix spelling mistakes and typos
  * stress-cpu: use the __builtin_parity function if it is available
  * core-vmstat: fix assignment that should be a comparison

